<?php
/**
 * Unreal Studio
 * Project: UnrealLicensing
 * User: jhollsoliver
 * Date: 03/06/15
 * Time: 16:37
 */
include 'system/autoloader.php';
if (isset($_GET["go"])) {
    $go = base64_decode($_GET['go']);
} else {
    $go = './';
}
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="">
    <meta name="author" content="Giovanne Oliveira">
    <link rel="shortcut icon" href="<?php echo ASSETS_URL; ?>/img/favicon.png">

    <title><?php echo PRODUCT_NAME; ?> Login</title>

    <!-- Bootstrap core CSS -->
    <link href="<?php echo ASSETS_URL; ?>/css/bootstrap.min.css" rel="stylesheet">
    <link href="<?php echo ASSETS_URL; ?>/css/bootstrap-reset.css" rel="stylesheet">
    <!--external css-->
    <link href="<?php echo ASSETS_URL; ?>/font-awesome/css/font-awesome.css" rel="stylesheet"/>
    <!-- Custom styles for this template -->
    <link href="<?php echo ASSETS_URL; ?>/css/style.css" rel="stylesheet">
    <link href="<?php echo ASSETS_URL; ?>/css/style-responsive.css" rel="stylesheet"/>
    <!--toastr-->
    <link href="<?php echo ASSETS_URL; ?>/toastr-master/toastr.css" rel="stylesheet" type="text/css"/>

    <link href="https://cdnjs.cloudflare.com/ajax/libs/Ladda/1.0.0/ladda-themeless.min.css" rel="stylesheet" type="text/css"/>

    <!-- HTML5 shim and Respond.js IE8 support of HTML5 tooltipss and media queries -->
    <!--[if lt IE 9]>
    <script src="<?php echo ASSETS_URL;?>/js/html5shiv.js"></script>
    <script src="<?php echo ASSETS_URL;?>/js/respond.min.js"></script>
    <![endif]-->
    <style>
        .custom-txtbox{
            text-align:center;
            width:20%;
            margin:0 auto;
        }
    </style>
</head>

<body class="login-body">

<div class="container">

    <form class="form-signin" id="frmLogin">
        <h2 class="form-signin-heading"><?php echo PRODUCT_NAME; ?> LOGIN</h2>

        <div class="login-wrap">
            <input type="text" class="form-control" id="txtUser" placeholder="User ID" autofocus>
            <input type="password" class="form-control" id="txtPass" placeholder="Password">
            <label class="checkbox">
                <span class="pull-right">
                    <a data-toggle="modal" href="#myModal"> Forgot Password?</a>

                </span>
            </label>
            <button class="btn btn-lg btn-login ladda-button btn-block" id="btnDoLogin" data-style="zoom-in" type="submit"><span class="ladda-label">Sign in</span></button>


        </div>
    </form>


    <!-- Modal -->
    <div aria-hidden="true" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="myModal" class="modal fade">
        <div class="modal-dialog">
            <form id="frmRecoverPwd">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                        <h4 class="modal-title">Forgot Password ?</h4>
                    </div>
                    <div class="modal-body">
                        <p>Enter your username below to reset your password.</p>
                        <input type="text" name="username" id="recoverEmail" placeholder="E-mail" autocomplete="off"
                               class="form-control placeholder-no-fix">

                    </div>
                    <div class="modal-footer">
                        <button data-dismiss="modal" class="btn btn-default" type="button">Cancel</button>
                        <button class="btn btn-success" id="btnSubmitResetPwd" type="submit">Submit</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <!-- modal -->

    <!-- Modal -->
    <div aria-hidden="true" data-keyboard="false" data-backdrop="static" aria-labelledby="myModalLabel" role="dialog" tabindex="-1" id="mdl2FA" class="modal fade">
        <div class="modal-dialog">
            <form id="frmSubmitGAuth">
                <div class="modal-content">
                    <div class="modal-header">
                        <!--<button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>-->
                        <h4 class="modal-title">2-Factor Authentication</h4>
                    </div>
                    <div class="modal-body">
                        <p>Your account is configured to require a second factor authentication. Please input your Token generated by Google Authenticator or Authy.</p>
                        <input type="text" name="GAuthToken" id="GAuthToken" placeholder="Token" data-mask="999 999" autocomplete="off"
                               class="form-control input-lg custom-txtbox placeholder-no-fix">
                        <input type="hidden" id="hdnSeed">

                    </div>
                    <div class="modal-footer">
                        <button data-dismiss="modal" class="btn btn-default" type="button">Cancel</button>
                        <button class="btn btn-success ladda-button" id="btnSubmit2FA" data-style="zoom-in" type="submit"><span class="ladda-label">Verify</span></button>
                    </div>
                </div>
            </form>
        </div>
    </div>
    <!-- modal -->


</div>


<!-- js placed at the end of the document so the pages load faster -->
<script src="<?php echo ASSETS_URL; ?>/js/jquery.js"></script>
<script src="<?php echo ASSETS_URL; ?>/js/bootstrap.min.js"></script>
<!--toastr-->
<script src="<?php echo ASSETS_URL; ?>/toastr-master/toastr.js"></script>

<script type="text/javascript" src="<?php echo ASSETS_URL; ?>/bootstrap-inputmask/bootstrap-inputmask.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/Ladda/1.0.0/spin.min.js"></script>
<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/Ladda/1.0.0/ladda.min.js"></script>


</body>
</html>

<script>
    $(function () {
        //$("#frmLogin").jCryption();
        toastr.options = {
            "closeButton": true,
            "debug": false,
            "progressBar": true,
            "positionClass": "toast-top-right",
            "onclick": null,
            "showDuration": "300",
            "hideDuration": "1000",
            "timeOut": "3000",
            "extendedTimeOut": "1000",
            "showEasing": "swing",
            "hideEasing": "linear",
            "showMethod": "fadeIn",
            "hideMethod": "fadeOut"
        }
        $("#frmLogin").submit(function (e) {
            e.preventDefault();

            var username = $("#txtUser").val();
            var password = $("#txtPass").val();
            var l = Ladda.create( document.querySelector( '#btnDoLogin' ) );
            $.ajax({

                type: "POST",
                data: {
                    user: username,
                    pass: password,
                    handler: 'login'
                },

                url: "ajax/",
                dataType: "json",
                success: function (result) {

                    if (result.status == 200) {
                        if(result.twofactor == true)
                        {
                            Create2FADialogbox(result.seed);
                        }else{
                            $(window.document.location).attr('href', '<?php echo $go;?>');
                        }

                    } else {
                        l.stop();
                        toastr[result.message.type](result.message.text, result.message.header);
                    }


                },
                beforeSend: function () {

                    l.start();

                },
                error: function () {
                    l.stop();
                    toastr['error']("Unknown Error. Contact the support team.", "Oops!");
                }
            });
            return false;
        });

        $("#frmRecoverPwd").submit(function (e) {
            e.preventDefault();

            var email = $("#recoverEmail").val();
            var btn = $("#btnSubmitResetPwd");
            $.ajax({

                type: "POST",
                data: {
                    email: email,
                    handler: 'resetpwd'
                },

                url: "ajax/",
                dataType: "json",
                success: function (result) {

                    if (result.status == 200) {
                        btn.html('Processed.');
                        toastr[result.message.type](result.message.text, result.message.header);
                    } else {
                        btn.html('Submit');
                        toastr[result.message.type](result.message.text, result.message.header);
                        btn.removeClass('disabled');
                    }


                },
                beforeSend: function () {

                    btn.html('Processing...');
                    btn.addClass('disabled');

                },
                error: function () {
                    btn.removeClass('disabled');
                    btn.html('Submit');
                    toastr[error]("Unknown Error. Contact the support team.", "Oops!");
                }
            });
            return false;
        });

        $("#frmSubmitGAuth").submit(function (e) {
            e.preventDefault();

            var l = Ladda.create( document.querySelector( '#btnSubmit2FA' ) );
            $.ajax({

                type: "POST",
                data: {
                    token: $("#GAuthToken").val(),
                    seed:$("#hdnSeed").val(),
                    handler: '2fa-authenticate'
                },

                url: "ajax/",
                dataType: "json",
                success: function (result) {

                    if (result.status == 200) {
                        $(window.document.location).attr('href', '<?php echo $go;?>');
                    } else {
                        l.stop();
                        toastr[result.message.type](result.message.text, result.message.header);
                    }


                },
                beforeSend: function () {

                    l.start();

                },
                error: function () {
                    l.stop();
                    toastr['error']("Unknown Error. Contact the support team.", "Oops!");
                }
            });
            return false;
        });


    });

    function Create2FADialogbox(s)
    {
        $("#mdl2FA").modal('show');
        $("#hdnSeed").val(s);
    }

</script>
</body>
</html>